// Raptor.java

import ch.aplu.jgamegrid.*;
import java.awt.Color;
import java.util.*;

public class Raptor extends Bird
{
  public Raptor(GGVector startVelocity, double vraptor)
  {
    super(startVelocity, "sprites/raptor.gif", vraptor);
  }

  protected GGVector getNewAcceleration()  //Behavior of the RAPTOR: acceleration
  {
    GGVector distVec = new GGVector();
    GGVector nearestDistVecBird = new GGVector(0, 0);
    GGVector accAggression = new GGVector(0, 0);
    GGVector acceleration = new GGVector();
    double mag;
    double minmag = SimFlock.maxro;
    ArrayList<Actor> neighbourBirds = gameGrid.getActors(FlockBird.class);

    for (Actor neighbour : neighbourBirds)
    {
      FlockBird bird = (FlockBird) neighbour;
      distVec = getPositionVecDiffOnTorus(bird);
      mag = distVec.magnitude();
      if (mag <= SimFlock.roR)
      {
        if (mag < minmag)
        {
          minmag = mag;
          nearestDistVecBird = distVec.clone();
        }
      }
    }
    accAggression = nearestDistVecBird.mult(-SimFlock.aggressionFactor);
    acceleration.x = accAggression.x;
    acceleration.y = accAggression.y;
    return acceleration;
  }

  protected Color getColor()
  {
    return Color.RED;
  }

  protected void tryToEat()
  {
    ArrayList<Actor> victim = getNeighbours(2, FlockBird.class);
    if (!victim.isEmpty())
    {
      victim.get(0).removeSelf();
    }
  }
}
